#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    string s;
	getline(cin, s);
    int n = s.size();
    // cout << n;

    vector <int> wor;
    // wor.push_back(0);
    int kol = 0;
    int hesh[n];
    for(int i = 0; i < n - 1; i++)
    {
        hesh[i] = kol;
        // cout << hesh[i] << " ";
        wor.push_back(i);
        for(;i < n - 1, s[i] <= s[i + 1];)
        {
            hesh[i] = kol;
            i++;
        }
        hesh[i] = kol;
        kol++;

    }
    if(s[n - 1] < s[n - 2])
    {
        wor.push_back(n - 1);
        kol++;
    }
    hesh[n - 1] = kol - 1;
    
    // for (int i = 0; i < n; i++)
    // {
    //     cout << hesh[i] << " ";
    // }
    // cout << "*\n";


    wor.resize(kol);
    int q;
    cin >> q;
    while(q--)
    {
        int a, b;
        cin >> a >> b;
        cout << hesh[b - 1] - hesh[a - 1] + 1;
        cout << "\n";
        
    }
}
